<?php
/**
 * @category   Newsroom
 * @package    Newsroom_Presskit
 * @author     dushyantjoshia@gmail.com
 * @copyright  This file was generated by using Module Creator(http://code.vky.co.in/magento-2-module-creator/) provided by VKY <viky.031290@gmail.com>
 * @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
 */

namespace Newsroom\Presskit\Block\Adminhtml\Items\Edit\Tab;

use Magento\Backend\Block\Widget\Form\Generic;
use Magento\Backend\Block\Widget\Tab\TabInterface;
use Newsroom\Presskit\Block\Images as ImagesBlock;

class Main extends Generic implements TabInterface {
	protected $_wysiwygConfig;

	public function __construct(
		\Magento\Backend\Block\Template\Context $context,
		\Magento\Framework\Registry $registry,

		\Magento\Framework\Data\FormFactory $formFactory,
		\Magento\Cms\Model\Wysiwyg\Config $wysiwygConfig,
		array $data = []
	) {
		$this->_wysiwygConfig = $wysiwygConfig;

		parent::__construct($context, $registry, $formFactory, $data);
	}

	/**
	 * {@inheritdoc}
	 */
	public function getTabLabel() {
		return __('Item Information');
	}

	/**
	 * {@inheritdoc}
	 */
	public function getTabTitle() {
		return __('Item Information');
	}

	/**
	 * {@inheritdoc}
	 */
	public function canShowTab() {
		return true;
	}

	/**
	 * {@inheritdoc}
	 */
	public function isHidden() {
		return false;
	}

	/**
	 * Prepare form before rendering HTML
	 *
	 * @return $this
	 * @SuppressWarnings(PHPMD.NPathComplexity)
	 * @SuppressWarnings(PHPMD.ExcessiveMethodLength)
	 */
	protected function _prepareForm() {
		$model = $this->_coreRegistry->registry('current_newsroom_presskit_items');
		/** @var \Magento\Framework\Data\Form $form */
		$form = $this->_formFactory->create();
		$form->setHtmlIdPrefix('item_');
		$fieldset = $form->addFieldset('base_fieldset', ['legend' => __('Item Information')]);
		if ($model->getId()) {
			$fieldset->addField('presskit_id', 'hidden', ['name' => 'presskit_id']);
		}
		$fieldset->addField(
			'title',
			'text',
			['name' => 'title', 'label' => __('Company Name'), 'title' => __('Company Name'), 'required' => true]
		);
		$fieldset->addField(
			'link',
			'text',
			['name' => 'link', 'label' => __('Link'), 'title' => __('Link'), 'required' => true]
		);
$fieldset->addField(
            'short_content',
            'text',
            ['name' => 'short_content', 'label' => __('Long Title'), 'title' => __('Long Title'), 'required' => true]
        );
$fieldset->addField(
            'content',
            'editor',
            [
                'name' => 'content',
                'label' => __('Content'),
                'title' => __('Content'),
                'style' => 'height:26em;',
                'required' => true,
                'config'    => $this->_wysiwygConfig->getConfig(),
                'wysiwyg' => true
            ]
        );
		$fieldset->addField(
			'base_image',
			'image',
			[
				'name' => 'base_image',
				'label' => __('Base Image'),
				'title' => __('Base Image'),
				'required' => false,
			]
		);
		
		$fieldset->addType(
			'image',
			\Newsroom\Presskit\Helper\Image\Custom::class
		);
		$form->setData('enctype', 'multipart/form-data');
		

		$fieldset->addField(
			'status',
			'select',
			['name' => 'status', 'label' => __('Status'), 'title' => __('Status'), 'options' => [0 => 'Disable', 1 => 'Enable'], 'required' => true]
		);

		$form->setValues($model->getData());
		$this->setForm($form);
		return parent::_prepareForm();
	}
}
